;==============================================================================
;  Procedury zwiazane z buforem LCD
;  Projekt:	Miernik energii i mocy na ADE7759
;==============================================================================

;	ADRES BUFORA w rejestrze Z

.cseg
;==============================================================================
WYSWIETL_WYNIK:
	; czyszczenie bufora drugiej linii LCD
	ldi	zl,  low(Bufor)
	ldi	zh, high(Bufor)
	ldi	r20, 14		; 14 spacji
	ldi	temp, ' '
CZYSC_B:	st	z+, temp		; czyszczenie spacjami
	dec	r20
	brne	CZYSC_B
	ldi	temp, 0
	st	z, temp		; koniec tekstu
	ldi	zl,  low(Bufor)
	ldi	zh, high(Bufor)	; Z trzyma adres poczatku bufora

;--------------------------------------
	; spr statusow...
	lds	temp, Status
	sbrc	temp, ST_U
	rjmp	SPR_S_U		; jesli =1 to sprawdzic jakie U wyswietlic
	sbrc	temp, ST_I
	rjmp	SPR_S_I		; jesli =1 to sprawdzic jakie I wyswietlic
	sbrc	temp, ST_M
	rjmp	SPR_S_M		; jesli =1 to spr jakie moce wyswietlic
	sbrc	temp, ST_E1
	rjmp	SPR_S_E1		; jesli =1 to sprawdzic jakie E wyswietlic
	sbrc	temp, ST_E2
	rjmp	SPR_S_E2		; jesli =1 to sprawdzic jakie E wyswietlic
	rjmp	WYSW_F		; jesli =1 to wyswietlic F


SPR_S_M:	lds	temp, Status_M
	sbrc	temp, STM_P
	rjmp	WYSW_P		; jesli =1 to wyswietlic P
	sbrc	temp, STM_Q
	rjmp	WYSW_Q		; jesli =1 to wyswietlic Q
	sbrc	temp, STM_S
	rjmp	WYSW_S		; jesli =1 to wyswietlic S
	rjmp	WYSW_PF		; jesli =1 to wyswietlic PF


SPR_S_U:	lds	temp, Status_U
	sbrc	temp, STU_RMS
	rjmp	WYSW_U_RMS		; wyswietlic RMS U
	sbrc	temp, STU_MAV
	rjmp	WYSW_U_MAV		; wyswietlic MAV (wartosc srednia)
	sbrc	temp, STU_AP
	rjmp	WYSW_U_AP		; wyswietlic amplitude dodatnia
	rjmp	WYSW_U_AM		; wyswietlic amplitude ujemna

SPR_S_I:	lds	temp, Status_I
	sbrc	temp, STI_RMS
	rjmp	WYSW_I_RMS		; wyswietlic RMS I
	sbrc	temp, STI_MAV
	rjmp	WYSW_I_MAV		; wyswietlic MAV (wartosc srednia)
	sbrc	temp, STI_AP
	rjmp	WYSW_I_AP		; wyswietlic amplitude dodatnia
	rjmp	WYSW_I_AM		; wyswietlic amplitude ujemna

SPR_S_E1:	lds	temp, Status_E1
	sbrc	temp, STE1_SUMA
	rjmp	WYSW_E1_S		; wyswietlic energie T1 suma
	sbrc	temp, STE1_OD
	rjmp	WYSW_E1_O		; wyswietlic energie T1 od
	sbrc	temp, STE1_ODDO
	rjmp	WYSW_E1_OO		; wyswietlic energie T1 oddo
	sbrc	temp, STE1_POZ
	rjmp	WYSW_E1_P		; wyswietlic energie T1 pozorna
	sbrc	temp, STE1_SEK
	rjmp	WYSW_E1_K		; energia sekundowa
	rjmp	WYSW_E1_D		; wyswietlic energie T1 sesji

SPR_S_E2:	lds	temp, Status_E2
	sbrc	temp, STE2_SUMA
	rjmp	WYSW_E2_S		; wyswietlic energie T2 suma
	sbrc	temp, STE2_OD
	rjmp	WYSW_E2_O		; wyswietlic energie T2 od
	sbrc	temp, STE2_ODDO
	rjmp	WYSW_E2_OO		; wyswietlic energie T2 oddo
	sbrc	temp, STE2_POZ
	rjmp	WYSW_E2_P		; wyswietlic energie T1 pozorna
	rjmp	WYSW_E2_D		; wyswietlic energie T2 sesji

;--------------------------------------
	; rejestr Z trzyma adres poczatku bufora
	; rejestry X i Y sa uzywane w procedurach konwersji bin2bcd
	; wolna od obliczen para rejestrow: r25:r24 jest wykorzystana
	;    na trzymanie adresu komunikatu
	; r23 zawiera znacznik taryfy
WYSW_P:	rcall	BF_P		; wypelnij bufor odpowiednimi znakami
	ldi	r25, high(2*txt_moc_p)	; laduj adres tekstu do wyswietlenia
	ldi	r24,  low(2*txt_moc_p)
	lds	bin0, Moc_P		; laduj wartosc odpowiedniej zmiennej
	lds	bin1, Moc_P+1
	rjmp	WYSW_PQS
	
WYSW_Q:	rcall	BF_Q
	ldi	r25, high(2*txt_moc_q)
	ldi	r24,  low(2*txt_moc_q)
	lds	bin0, Moc_Q
	lds	bin1, Moc_Q+1
	rjmp	WYSW_PQS

WYSW_S:	rcall	BF_S
	ldi	r25, high(2*txt_moc_s)
	ldi	r24,  low(2*txt_moc_s)
	lds	bin0, Moc_S
	lds	bin1, Moc_S+1
	;rjmp	WYSW_PQS

WYSW_PQS:	rcall	BIN_16_BCD		; konwersja wartosci na BCD
	rcall	ROZPAKUJ_BCD	; rozpakowanie bcd na cyfry i korekta do wyswietlenia
	rcall	WPISZ_WARTOSC_4_1	; wpis wartosci 5-cio cyfrowej do bufora
	movw	zl, r24		; adres odpowiedniego tekstu:  r25:r24 -> zh:zl
	rjmp	WYSW_LCD


WYSW_F:	rcall	BF_F
	ldi	r25, high(2*txt_czest)
	ldi	r24,  low(2*txt_czest)
	lds	bin0, Czestosc
	lds	bin1, Czestosc+1
	rcall	BIN_16_BCD
	rcall	ROZPAKUJ_BCD
	rcall	WPISZ_WARTOSC_3_2
	lds	bin0, Wypeln
	clr	bin1
	rcall	BIN_16_BCD
	rcall	ROZPAKUJ_BCD
	ldi	temp, 0b00110000
	or	cyfra1, temp
	std	z+11, cyfra1
	or	cyfra0, temp
	std	z+12, cyfra0
	movw	zl, r24
	rjmp	WYSW_LCD

WYSW_PF:	lds	bin0, Pf_mocy
	clr	bin1
	rcall	BF_PF
	ldi	r25, high(2*txt_wsp_m)
	ldi	r24,  low(2*txt_wsp_m)
	rcall	BIN_16_BCD
	rcall	ROZPAKUJ_BCD
	rcall	WPISZ_WARTOSC_3_2
	movw	zl, r24		; adres odpowiedniego tekstu:  r25:r24 -> zh:zl
	rjmp	WYSW_LCD


WYSW_U_RMS:	ldi	r25, high(2*txt_u_rms)	; laduj adres tekstu do wyswietlenia
	ldi	r24,  low(2*txt_u_rms)
	lds	bin0, Napiecie_rms
	lds	bin1, Napiecie_rms+1
	rjmp	WYSW_UX

WYSW_U_MAV:	ldi	r25, high(2*txt_u_mav)
	ldi	r24,  low(2*txt_u_mav)
	lds	bin0, Napiecie_mav
	lds	bin1, Napiecie_mav+1
	rjmp	WYSW_UX

WYSW_U_AP:	ldi	r25, high(2*txt_u_ap)
	ldi	r24,  low(2*txt_u_ap)
	lds	bin0, Napiecie_ap
	lds	bin1, Napiecie_ap+1
	rjmp	WYSW_UX

WYSW_U_AM:	ldi	r25, high(2*txt_u_am)
	ldi	r24,  low(2*txt_u_am)
	lds	bin0, Napiecie_am
	lds	bin1, Napiecie_am+1
	;rjmp	WYSW_UX

WYSW_UX:	rcall	BF_U		; wypelnij bufor znakami
	rjmp	WYSW_PQS		; reszta identycznie jak dla mocy


WYSW_I_RMS:	ldi	r25, high(2*txt_i_rms)	; laduj adres tekstu do wyswietlenia
	ldi	r24,  low(2*txt_i_rms)
	lds	bin0, Prad_rms
	lds	bin1, Prad_rms+1
	rjmp	WYSW_IX

WYSW_I_MAV:	ldi	r25, high(2*txt_i_mav)
	ldi	r24,  low(2*txt_i_mav)
	lds	bin0, Prad_mav
	lds	bin1, Prad_mav+1
	rjmp	WYSW_IX

WYSW_I_AP:	ldi	r25, high(2*txt_i_ap)
	ldi	r24,  low(2*txt_i_ap)
	lds	bin0, Prad_ap
	lds	bin1, Prad_ap+1
	rjmp	WYSW_IX

WYSW_I_AM:	ldi	r25, high(2*txt_i_am)
	ldi	r24,  low(2*txt_i_am)
	lds	bin0, Prad_am
	lds	bin1, Prad_am+1
	;rjmp	WYSW_IX

WYSW_IX:	movw	r2, bin0		; kopia wartosci
	rcall	BF_I		; wypelnij bufor znakami
	rcall	BIN_16_BCD		; konwersja wartosci na BCD
	rcall	ROZPAKUJ_BCD	; rozpakowanie bcd na cyfry i korekta do wyswietlenia
	rcall	WPISZ_WARTOSC_2_2	; wpis wartosci
	movw	zl, r24		; adres odpowiedniego tekstu:  r25:r24 -> zh:zl
	rjmp	WYSW_LCD


WYSW_E1_S:	ldi	yh, high(Energia1+3)	; laduj adres zmiennej (trzy bajty LSB sie odrzuca)
	ldi	yl,  low(Energia1+3)
	ldi	r23, '1'		; przekazanie numeru taryfy
	rjmp	WYSW_ES12
WYSW_E2_S:	ldi	yh, high(Energia2+3)
	ldi	yl,  low(Energia2+3)
	ldi	r23, '2'

WYSW_ES12:	ldi	r25, high(2*txt_en_sum)	; laduj adres tekstu do wyswietlenia
	ldi	r24,  low(2*txt_en_sum)
	rjmp	WYSW_EX


WYSW_E1_P:	ldi	yh, high(Energia1_poz+3)
	ldi	yl,  low(Energia1_poz+3)
	ldi	r23, '1'
	rjmp	WYSW_EP12
WYSW_E2_P:	ldi	yh, high(Energia2_poz+3)
	ldi	yl,  low(Energia2_poz+3)
	ldi	r23, '2'

WYSW_EP12:	ldi	r25, high(2*txt_en_poz)
	ldi	r24,  low(2*txt_en_poz)
	rjmp	WYSW_EX


WYSW_E1_O:	ldi	yh, high(Energia1_od+3)
	ldi	yl,  low(Energia1_od+3)
	ldi	r23, '1'
	rjmp	WYSW_EO12
WYSW_E2_O:	ldi	yh, high(Energia2_od+3)
	ldi	yl,  low(Energia2_od+3)
	ldi	r23, '2'

WYSW_EO12:	ldi	r25, high(2*txt_en_od)
	ldi	r24,  low(2*txt_en_od)
	lds	temp, Flagi3
	sbr	temp, 1<<f3EN_O
	sts	Flagi3, temp
	rjmp	WYSW_EX


WYSW_E1_OO:	ldi	yh, high(Energia1_oddo+3)
	ldi	yl,  low(Energia1_oddo+3)
	ldi	r23, '1'
	rjmp	WYSW_EOO12
WYSW_E2_OO:	ldi	yh, high(Energia2_oddo+3)
	ldi	yl,  low(Energia2_oddo+3)
	ldi	r23, '2'

WYSW_EOO12:	ldi	r25, high(2*txt_en_oddo)
	ldi	r24,  low(2*txt_en_oddo)
	lds	temp, Flagi3
	sbr	temp, 1<<f3EN_OO
	sts	Flagi3, temp
	rjmp	WYSW_EX


WYSW_E1_K:	ldi	yh, high(Energia_sek)
	ldi	yl,  low(Energia_sek)
	ldi	r23, 'S'
	ldi	r25, high(2*txt_en_sek)
	ldi	r24,  low(2*txt_en_sek)
	rjmp	WYSW_EX


WYSW_E1_D:	ldi	yh, high(Energia1_ses+3)
	ldi	yl,  low(Energia1_ses+3)
	ldi	r23, '1'
	rjmp	WYSW_ED12
WYSW_E2_D:	ldi	yh, high(Energia2_ses+3)
	ldi	yl,  low(Energia2_ses+3)
	ldi	r23, '2'

WYSW_ED12:	ldi	r25, high(2*txt_en_ses)
	ldi	r24,  low(2*txt_en_ses)
	;rjmp	WYSW_EX


WYSW_EX:	rcall	OBRB_EN		; zaladowanie, konwersja, wypelnienie bufora
	;rjmp	WYSW_LCD


;--------------------------------------
WYSW_LCD:	; wyswietlanie na LCD
	ldi	temp, LCD_LINE_1
	rcall	LCD_COMMAND		; linia pierwsza
	rcall	LCD_STR_FLASH	; wyswietl linie pierwsza (tekst)
	ldi	temp, ' '
	rcall	LCD_CHAR		; miejsce 15-te na LCD
	sbrs	flagi, fTARYFY	; przeskocz jesli licznik dwutaryfowy
	rjmp	WL_CHR1
	ldi	temp, '1'
	sbrc	flagi, fTARYFA2	; ktora taryfa?
	ldi	temp, '2'
WL_CHR1:	rcall	LCD_CHAR

	lds	temp, Flagi3
	sbrc	temp, f3EN_O	; przeskocz jesli Energia_od niewyswietlana
	rjmp	WPISZ_DATE_O	; uzupelnia napis w pierwszej linii LCD
	sbrc	temp, f3EN_OO	; przeskocz jesli Energia_oddo niewyswietlana
	rjmp	WPISZ_DATE_OO	; uzupelnia napis w pierwszej linii LCD
WL_LINE2:	lds	temp, Flagi3
	cbr	temp, (1<<f3EN_O) | (1<<f3EN_OO)
	sts	Flagi3, temp

	ldi	temp, LCD_LINE_2
	rcall	LCD_COMMAND		; linia druga
	ldi	zl,  low(Bufor)
	ldi	zh, high(Bufor)
	rcall	LCD_STR_RAM		; wyswietl linie druga

	ldi	temp, ' '
	lds	r0, Flagi2
	sbrc	r0, f2EN_MI		; test ujemnej ostatniej probki energii
	ldi	temp, '*'		; informacja o ujemnej probce energii
	rcall	LCD_CHAR

	sbrc	flagi, fOVER_I
	rjmp	OV_GWI		; jesli flaga =1 to wystapilo przepelnienie
	sbrc	flagi, fOVER_U
	rjmp	OV_GWI		; jesli flaga =1 to wystapilo przepelnienie
	ldi	temp, ' '		; miejsce 16-te
	rcall	LCD_CHAR
	ldi	temp, LCD_D1_C0_B0	; brak przepelnienia, wiec brak migotania
	rcall	LCD_COMMAND
	ret
	; koniec WYSWIETL_WYNIK

OV_GWI:	; przepelnienie sygnalizowane migajacym 'P'
	ldi	temp, 'P'		; informacja o przepelnieniu
	rcall	LCD_CHAR
	ldi	temp, LCD_CURSOR_LEFT	; cofnij
	rcall	LCD_COMMAND
	ldi	temp, LCD_D1_C0_B1	; migaj
	rcall	LCD_COMMAND
	ret


;==============================================================================
;==============================================================================
OBRB_EN:	; test akumulatora energii na wartosc ujemna
	ld	bin0, y+		; zaladowanie wartosci zmiennej
	ld	bin1, y+
	ld	bin2, y+
	ld	bin3, y+
	; test znaku
	sbrs	bin3, 7
	rjmp	OBE_P
	; akumulator ujemny -negacja
	com	bin0
	com	bin1
	com	bin2
	com	bin3
	ldi	temp, 1
	add	bin0, temp
	clr	temp
	adc	bin1, temp
	adc	bin2, temp
	adc	bin3, temp
	ldi	temp, '-'		; znak liczby ujemnej '-'
	std	z+3, temp		; ...zapisz w Buforze

OBE_P:	; sprawdzanie wartosci
	lds	temp, Flagi2
	push	temp		; zachowuje stan Flagi2
	ldi	bcd0,   low(9999999)
	ldi	bcd1, byte2(9999999)
	ldi	bcd2, byte3(9999999)
	ldi	bcd3, byte4(9999999)	; maksymalna wartosc na LCD
	cp	bcd0, bin0
	cpc	bcd1, bin1
	cpc	bcd2, bin2
	cpc	bcd3, bin3
	brsh	OBE_OK		; skacz jesli wartosc "energii" <= od maksymalnej na LCD
	cbr	temp, 1<<f2EN_WH	; czysc flage Wh
	sts	Flagi2, temp
	rjmp	OBE_OK
OBE_OK:	rcall	BIN_32_BCD		; konwersja wartosci na BCD
	rcall	ROZPAKUJ_BCD	; rozpakowanie bcd na cyfry i korekta do wyswietlenia
	rcall	BF_E		; wypelnij bufor znakami
	rcall	WPISZ_WARTOSC_7	; wpis wartosci
	pop	temp		; odtwarza stan Flagi2
	sts	Flagi2, temp
	movw	zl, r24		; adres odpowiedniego tekstu:  r25:r24 -> zh:zl
	ret


;------------------------------------------------------------------------------
;------------------------------------------------------------------------------
BF_P:	; wypelnienie bufora mocy P
	ldi	temp, 'P'
	st	z, temp		; Z trzyma adres poczatku bufora
	ldi	temp, 'W'
	std	z+9, temp
	rjmp	BF_PQS
;--------------------------------------
BF_Q:	; wypelnienie bufora mocy Q
	ldi	temp, 'Q'
	st	z, temp
	ldi	temp, 'v'
	std	z+9, temp
	ldi	temp, 'a'
	std	z+10, temp
	ldi	temp, 'r'
	std	z+11, temp
	rjmp	BF_PQS
;--------------------------------------
BF_S:	; wypelnienie bufora mocy S
	ldi	temp, 'S'
	st	z, temp
	ldi	temp, 'V'
	std	z+9, temp
	ldi	temp, 'A'
	std	z+10, temp
BF_PQS:	ldi	temp, '='
	std	z+1, temp
	ldi	temp, ','
	std	z+7, temp
	ret

;------------------------------------------------------------------------------
BF_U:	; wypelnienie bufora U
	ldi	temp, 'U'
	st	z, temp
	ldi	temp, '='
	std	z+1, temp
	ldi	temp, ','
	std	z+7, temp
	ldi	temp, 'V'
	std	z+9, temp
	sbrs	flagi, fOVER_U
	ret			; brak przepelnienia jesli flaga =0
	; przepelnienie sygnalizowane "max"
BFU_P:	ldi	temp, 'm'
	std	z+10, temp
	ldi	temp, 'a'
	std	z+11, temp
	ldi	temp, 'x'
	std	z+12, temp
	ret

;--------------------------------------
BF_I:	; wypelnienie bufora I
	ldi	temp, 'I'
	st	z, temp
	ldi	temp, '='
	std	z+1, temp
;	ldi	temp, ','
;	std	z+5, temp
	ldi	temp, 'm'
	std	z+7, temp
	ldi	temp, 'A'
	std	z+8, temp
	sbrs	flagi, fOVER_I
	ret			; brak przepelnienia jesli flaga =0
	rjmp	BFU_P

;------------------------------------------------------------------------------
BF_E:	; wypelnienie bufora Energii
	ldi	temp, 'E'
	st	z, temp
	std	z+1, r23		; r23 trzyma znacznik taryfy
	ldi	temp, '='
	std	z+2, temp
	lds	temp, Flagi2
	sbrc	temp, f2EN_WH	; jesli f2EN_WH=0 to wyswietlanie w kWh
	rjmp	BFE_WH
	ldi	temp, 'k'
	std	z+11, temp
	ldi	temp, 'W'
	std	z+12, temp
	ldi	temp, 'h'
	std	z+13, temp
	ret
BFE_WH:	ldi	temp, 'W'
	std	z+11, temp
	ldi	temp, 'h'
	lds	r0, Status_E1
	sbrc	r0, STE1_SEK	; dla Energia_SEK jednostka to [Ws]
	ldi	temp, 's'
	std	z+12, temp
	ret

;------------------------------------------------------------------------------
BF_F:	; wypelnienie bufora czestotliwosci
	ldi	temp, 'F'
	st	z, temp
	ldi	temp, '='
	std	z+1, temp
	ldi	temp, ','
	std	z+5, temp
	ldi	temp, 'H'
	std	z+8, temp
	ldi	temp, 'z'
	std	z+9, temp
	ldi	temp, '%'
	std	z+13, temp
	ret

;------------------------------------------------------------------------------
BF_PF:	; wypelnienie bufora wsp. mocy
	ldi	temp, 'P'
	st	z, temp
	ldi	temp, 'F'
	std	z+1, temp
	ldi	temp, '='
	std	z+2, temp
	ldi	temp, ','
	std	z+5, temp
	ret


;==============================================================================
WPISZ_DATE_O:	; wpisuje date dla Energii_od
	ldi	temp, LCD_LINE_1 | 6
	rcall	LCD_COMMAND
	lds	r0, Od_dzien_st
	rcall	HEX_1B
	ldi	temp, '.'
	rcall	LCD_CHAR
	lds	r0, Od_mies_st
	rcall	HEX_1B
	ldi	temp, '.'
	rcall	LCD_CHAR
	lds	r0, Od_rok_st
	rcall	HEX_1B
	rjmp	WL_LINE2

;--------------------------------------
WPISZ_DATE_OO:	; wpisuje date dla Energii_oddo
	ldi	temp, LCD_LINE_1 | 3
	rcall	LCD_COMMAND
	lds	r0, Oddo_dzien_st
	rcall	HEX_1B
	ldi	temp, '.'
	rcall	LCD_CHAR
	lds	r0, Oddo_mies_st
	rcall	HEX_1B
	ldi	temp, '-'
	rcall	LCD_CHAR
	lds	r0, Oddo_dzien_sp
	rcall	HEX_1B
	ldi	temp, '.'
	rcall	LCD_CHAR
	lds	r0, Oddo_mies_sp
	rcall	HEX_1B
	rjmp	WL_LINE2


;------------------------------------------------------------------------------
;------------------------------------------------------------------------------
WPISZ_WARTOSC_4_1:	; wpis wartosci 5-cio cyfrowej -- przecinek za 1 miejscem od konca
	ldi	temp, 3		; licznik cyfr PRZED przecinkiem
	mov	r0, temp
	clr	yh
	ldi	yl, adrcyfra0+5	; adres rejestrow cyfra + cyfra5
	adiw	zl, 3		; ustaw adres bufora na poczatku pola wartosci
	clt			; czysc flage zer nieznaczacych

WW51_1:	ld	temp, -y		; laduj cyfre
	brts	WW51_2		; jesli T=1 to nie sprawdzaj zer nieznaczacych
	cpi	temp, '0'
	breq	WW51_3		; jesli ='0' to skacz
	set			; ustaw flage zer nieznacz.
WW51_2:	st	z, temp		; zapisz cyfre w buforze
WW51_3:	adiw	zl, 1
	dec	r0
	brne	WW51_1

	st	z, cyfra1
	std	z+2, cyfra0
	ret

;------------------------------------------------------------------------------
WPISZ_WARTOSC_2_2:	; wpis wartosci 4-cio cyfrowej -- przecinek za 2 miejscem od konca
	tst	r3		; jesli wartosc <256 to rozdzielczosc 1mA
	breq	WW22_2

	mov	temp, cyfra4
	cpi	temp, '0'
	breq	WW22_1		; jesli rowne, to skacz
	std	z+3, temp		; jesli <> to zapisz cyfre w buforze
WW22_1:	std	z+4, cyfra3
	std	z+6, cyfra2		; omin przecinek
	std	z+7, cyfra1
	ldi	temp, ','
	std	z+5, temp
	ret
WW22_2:	mov	temp, cyfra2
	cpi	temp, '0'
	breq	WW22_3		; jesli rowne, to skacz
	std	z+4, temp		; jesli <> to zapisz cyfre w buforze
WW22_3:	mov	temp, cyfra1
	cpi	temp, '0'
	breq	WW22_4
	std	z+5, temp
WW22_4:	std	z+6, cyfra0
	ret

;------------------------------------------------------------------------------
WPISZ_WARTOSC_3_2:	; wpisywanie wartosci 5-cyfrowej (dla F i PF)
	mov	temp, cyfra4
	cpi	temp, '0'
	breq	WW32_1		; jesli rowne, to skacz
	std	z+2, temp		; jesli <> to zapisz cyfre w buforze
WW32_1:	mov	temp, cyfra3
	cpi	temp, '0'
	breq	WW32_2
	std	z+3, temp
WW32_2:	std	z+4, cyfra2
	std	z+6, cyfra1		; omin przecinek
	std	z+7, cyfra0
	ret



;------------------------------------------------------------------------------
WPISZ_WARTOSC_7:
	ldi	temp, 6
	mov	r0, temp		; licznik cyfr
	clr	yh

	ldi	yl, adrcyfra0+7+3	; adres rejestrow cyfra + cyfra10 (kWh)
	lds	temp, Flagi2
	sbrc	temp, f2EN_WH	; przeskocz jesli EN_WH=0 (kWh)
	ldi	yl, adrcyfra0+7	; adres rejestrow cyfra + cyfra7 (Wh)
	adiw	zl, 4		; ustaw adres bufora na poczatku pola wartosci
	clt			; czysc flage zer nieznaczacych

WW7_1:	ld	temp, -y		; laduj cyfre
	brts	WW7_2		; jesli T=1 to nie sprawdzaj zer nieznaczacych
	cpi	temp, '0'
	breq	WW7_3		; jesli ='0' to skacz
	set			; ustaw flage zer nieznacz.
WW7_2:	st	z, temp		; zapisz cyfre w buforze
WW7_3:	adiw	zl, 1
	dec	r0
	brne	WW7_1

	ld	temp, -y		; ostatnia cyfra
	st	z, temp

	ret

	

.exit
;------------------------------------------------------------------------------
